
#ifndef _HASHCALC_H
#define _HASHCALC_H

#include <windows.h>
#define _BUFFER_SIZE 1048576

class HashCalc
{
public:

	typedef enum _ALGORITHM_TYPE
	{
		E_CRC32,   // NO HMAC
		E_ADLER32, // NO HMAC
		E_TIGER,
		E_PANAMA,
		E_WHIRLPOOL,
		E_MD2,
		E_MD4,
		E_MD5,
		E_RIPEMD_128,
		E_RIPEMD_160,
		E_RIPEMD_256,
		E_RIPEMD_320,
		E_SHA1,
		E_SHA2_224,
		E_SHA2_256,
		E_SHA4_384,
		E_SHA4_512
	}	ALGORITHM_TYPE;

public:

	HashCalc(ALGORITHM_TYPE AlgorithmType);
	virtual ~HashCalc();

	tstring GetStringResult(string strInputA, // ַANSI
		string strKeyA,                       // ַANSI
		BOOL bHmac, BOOL bUppercase);

	tstring GetFileResult(TCHAR* szInFile, 
		string strKeyA,                       // ַANSI
		BOOL bHmac, BOOL bUppercase, MemberFxn addr);

	void FileStop()
	{
		m_bExit = TRUE;
	}

	BOOL IsUserStop()
	{
		return m_bExit;
	}

	// ȡ
	DWORD GetError();

private:

	//
	// ַANSI,
	// мtstring(ANSIUNICODE), Աʾ
	//

	tstring string_crc32      (string strInputA, string strKeyA, BOOL bUppercase);
	tstring string_adler32    (string strInputA, string strKeyA, BOOL bUppercase);
	tstring string_tiger      (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_panama     (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_whirlpool  (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_md2        (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_md4        (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_md5        (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_ripemd_128 (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_ripemd_160 (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_ripemd_256 (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_ripemd_320 (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_sha1       (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_sha2_224   (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_sha2_256   (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_sha4_384   (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);
	tstring string_sha4_512   (string strInputA, string strKeyA, BOOL bHmac, BOOL bUppercase);

	//
	// If there are error occurs, the result is _T("")
	// get extended error information call member function [GetError]
	// 

	tstring file_crc32      (TCHAR* szInFile, string strKeyA, BOOL bUppercase, MemberFxn addr);
	tstring file_Adler32    (TCHAR* szInFile, string strKeyA, BOOL bUppercase, MemberFxn addr);
	tstring file_tiger      (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_panama     (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_whirlpool  (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_md2        (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_md4        (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_md5        (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_ripemd_128 (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_ripemd_160 (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_ripemd_256 (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_ripemd_320 (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_sha1       (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_sha2_224   (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_sha2_256   (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_sha4_384   (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);
	tstring file_sha4_512   (TCHAR* szInFile, string strKeyA, BOOL bHmac, BOOL bUppercase, MemberFxn addr);

	// ļ
	DWORD CalcProgress(DWORD64 dwFileSize, DWORD64 dwCurrent);

	// 
	// ûṩĻص, ûݵǰļ
	// 
	//
	void CallMember(MemberFxn addr, int nProgress/* 1-100 */);

private:

	ALGORITHM_TYPE m_Type;
	MemberFxn m_Addr;
	DWORD m_dwErr;
	BOOL m_bExit;
};

#endif // _HASHCALC_H
