// HashDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Hash.h"
#include "HashDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	HyperLink m_LinkWeb, m_LinkMail;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_LinkWeb.Attach(GetDlgItem(IDC_STATIC_WEB)->m_hWnd);
	m_LinkMail.Attach(GetDlgItem(IDC_STATIC_MAIL)->m_hWnd);

	m_LinkWeb.SetURL(_T("http://www.zhangluduo.com/"));
	m_LinkMail.SetURL(_T("mailto:support@zhangluduo.com"));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHashDlg dialog

CHashDlg::CHashDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHashDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHashDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHashDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHashDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Pos);
	DDX_Control(pDX, IDC_COMBO_ALGORITHM, m_cbxAlgorithm);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHashDlg, CDialog)
	//{{AFX_MSG_MAP(CHashDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO_STRING, OnRadioString)
	ON_BN_CLICKED(IDC_RADIO_FILE, OnRadioFile)
	ON_CBN_SELCHANGE(IDC_COMBO_ALGORITHM, OnSelchangeComboAlgorithm)
	ON_BN_CLICKED(IDC_CHECK_HMAC, OnCheckHmac)
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	ON_BN_CLICKED(IDC_BTN_COPY, OnBtnCopy)
	ON_BN_CLICKED(IDC_BTN_CALCULATE, OnBtnCalculate)
	ON_BN_CLICKED(IDC_CHECK_UPPDRCASE, OnCheckUppdrcase)
	ON_BN_CLICKED(IDC_BTN_ABOUT, OnBtnAbout)
	ON_EN_CHANGE(IDC_EDIT_DATA, OnChangeEditData)
	ON_EN_CHANGE(IDC_EDIT_KEY, OnChangeEditKey)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHashDlg message handlers

BOOL CHashDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//
	// رʼ
	//

	m_bIsStarting = FALSE;
	m_pHashCalc   = NULL;

	//
	// ʼб
	//

	m_cbxAlgorithm.AddString(_T("CRC32"));   // NO HMAC
	m_cbxAlgorithm.AddString(_T("Adler32")); // NO HMAC
	m_cbxAlgorithm.AddString(_T("Tiger"));
	m_cbxAlgorithm.AddString(_T("Panama"));	
	m_cbxAlgorithm.AddString(_T("Whirlpool"));
	m_cbxAlgorithm.AddString(_T("MD2"));
	m_cbxAlgorithm.AddString(_T("MD4"));
	m_cbxAlgorithm.AddString(_T("MD5"));
	m_cbxAlgorithm.AddString(_T("RIPEMD-128"));
	m_cbxAlgorithm.AddString(_T("RIPEMD-160"));
	m_cbxAlgorithm.AddString(_T("RIPEMD-256"));
	m_cbxAlgorithm.AddString(_T("RIPEMD-320"));
	m_cbxAlgorithm.AddString(_T("SHA1"));
	m_cbxAlgorithm.AddString(_T("SHA2-224"));
	m_cbxAlgorithm.AddString(_T("SHA2-256"));
	m_cbxAlgorithm.AddString(_T("SHA4-384"));
	m_cbxAlgorithm.AddString(_T("SHA4-512"));
	m_cbxAlgorithm.SetCurSel(0);

	//
	// ʼؼ״̬
	//

	AdjustDataSourceEditWnd(TRUE);
	((CButton*)GetDlgItem(IDC_RADIO_STRING))->SetCheck(TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY)->m_hWnd, FALSE);
	::EnableWindow(GetDlgItem(IDC_CHECK_HMAC)->m_hWnd, FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHashDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if(nID == SC_CLOSE)
	{
		if(!m_bIsStarting)
		{
			CDialog::OnSysCommand(nID, lParam);
			return;
		}

		CString strMsg;
		strMsg.LoadString(IDS_EXIT_MSG);
		
		if (IDYES == ::MessageBox(m_hWnd, strMsg, 
			_T("Warning"), MB_YESNO | MB_ICONWARNING))
		{
			CDialog::OnSysCommand(nID, lParam);
		}	
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHashDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHashDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHashDlg::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	int nFiles = ::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, NULL);

	if (nFiles > 0)
	{
		TCHAR szFileName[MAX_PATH] = { 0 };
		::DragQueryFile(hDropInfo, 0, szFileName, MAX_PATH);

		if(!(GetFileAttributes(szFileName) & FILE_ATTRIBUTE_DIRECTORY))
		{
			SetDlgItemText(IDC_EDIT_DATA, szFileName);
		}
	}
	CDialog::OnDropFiles(hDropInfo);
}

/***************************************
Դ(String, File)
Ƿʾ[Browse]ť
***************************************/
void CHashDlg::AdjustDataSourceEditWnd(BOOL bFlag)
{
	RECT rtDataType, rtResult;
	
	::GetWindowRect(GetDlgItem(IDC_COMBO_ALGORITHM)->m_hWnd, &rtDataType);
	::GetWindowRect(GetDlgItem(IDC_EDIT_RESULT)->m_hWnd, &rtResult);

	/*TRUE for String data type, Otherwise FALSE*/
	if (bFlag)
	{
		GetDlgItem(IDC_EDIT_DATA)->SetWindowPos(NULL, 0, 0,
			rtDataType.right - rtDataType.left,
			rtDataType.bottom - rtDataType.top, 
			SWP_NOMOVE | SWP_NOOWNERZORDER);

		((CEdit*)GetDlgItem(IDC_EDIT_DATA))->SetReadOnly(FALSE);
		::ShowWindow(GetDlgItem(IDC_BTN_BROWSE)->m_hWnd, SW_HIDE);
		::DragAcceptFiles(m_hWnd, FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN_CALCULATE)->m_hWnd, FALSE);
		SetDlgItemText(IDC_EDIT_DATA, _T(""));
		SetDlgItemText(IDC_EDIT_RESULT, _T(""));
	}
	else
	{
		GetDlgItem(IDC_EDIT_DATA)->SetWindowPos(NULL, 0, 0,
			rtResult.right - rtResult.left,
			rtResult.bottom - rtResult.top, 
			SWP_NOMOVE | SWP_NOOWNERZORDER);

		((CEdit*)GetDlgItem(IDC_EDIT_DATA))->SetReadOnly(TRUE);
		::ShowWindow(GetDlgItem(IDC_BTN_BROWSE)->m_hWnd, SW_SHOW);
		::DragAcceptFiles(m_hWnd, TRUE);
		::EnableWindow(GetDlgItem(IDC_BTN_CALCULATE)->m_hWnd, TRUE);
		SetDlgItemText(IDC_EDIT_DATA, _T(""));
		SetDlgItemText(IDC_EDIT_RESULT, _T(""));
	}
}

/***************************************
[String]ѡť
***************************************/
void CHashDlg::OnRadioString() 
{
	AdjustDataSourceEditWnd(TRUE);
	::SetFocus(GetDlgItem(IDC_EDIT_DATA)->m_hWnd);
}

/***************************************
[File]ѡť
***************************************/
void CHashDlg::OnRadioFile() 
{
	AdjustDataSourceEditWnd(FALSE);
}

/***************************************
ļ
***************************************/
void CHashDlg::OnBtnBrowse() 
{
	vector<tstring> Files = m_FileDlg.GetOpenFileName(m_hWnd);
	if (Files.size() <= 0)
		return;

	SetDlgItemText(IDC_EDIT_DATA, Files[0].c_str());
}

/***************************************
ϵͳ
***************************************/
void CHashDlg::OnBtnCopy() 
{
//	CString strResult;
//	GetDlgItemText(IDC_EDIT_RESULT, strResult);
//	if (strResult.IsEmpty())
//	{
//		return;
//	}

	// The variant len not including the terminating null character
	int len = ::SendMessageA(GetDlgItem(IDC_EDIT_RESULT)->m_hWnd, WM_GETTEXTLENGTH, 0, 0);
//	if (0 >= len)
//		return;

	char* pszResult = new char[len + 1];
	memset(pszResult, 0, len + 1);
	::SendMessageA(GetDlgItem(IDC_EDIT_RESULT)->m_hWnd, WM_GETTEXT, len + 1, (LONG)pszResult);
	
    if (!::OpenClipboard(m_hWnd)) 
	{
		delete pszResult;
        return ; 
	}
    ::EmptyClipboard(); 

	if (0 >= len)
	{
		delete pszResult;
		return;
	}

    HGLOBAL hglbCopy = GlobalAlloc(GMEM_MOVEABLE, len + 1);
    if (hglbCopy == NULL) 
    { 
        CloseClipboard(); 
		delete pszResult;
        return ; 
    } 

	LPTSTR lptstrCopy = (LPTSTR)::GlobalLock(hglbCopy); 
	memcpy(lptstrCopy, pszResult, len);

	lptstrCopy[len + 1] = (TCHAR) 0;
	GlobalUnlock(hglbCopy); 

	SetClipboardData(CF_TEXT, hglbCopy); 
	CloseClipboard();

	delete pszResult;

	AfxMessageBox(_T("The result copied to clipboard successed!"));
}

/***************************************
Сдת
***************************************/
void CHashDlg::OnCheckUppdrcase() 
{
	CString strResult;
	GetDlgItemText(IDC_EDIT_RESULT, strResult);
	if (strResult.IsEmpty())
		return;

	BOOL bUppercase = 
		((CButton*)GetDlgItem(IDC_CHECK_UPPDRCASE))->GetCheck();	

	if (bUppercase)
	{
		strResult = CharUpper((LPTSTR)(LPCTSTR)strResult);
		SetDlgItemText(IDC_EDIT_RESULT, strResult);
	}
	else
	{
		strResult = CharLower((LPTSTR)(LPCTSTR)strResult);
		SetDlgItemText(IDC_EDIT_RESULT, strResult);
	}	
}

/***************************************
ʾ[]Ի
***************************************/
void CHashDlg::OnBtnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

/***************************************
˳ǰжһǷļڱ
***************************************/
void CHashDlg::OnOK() 
{
	// TODO: Add extra validation here

	if(!m_bIsStarting)
	{
		CDialog::OnOK();
		return;
	}

	CString strMsg;
	strMsg.LoadString(IDS_EXIT_MSG);
	
	if (IDYES == ::MessageBox(m_hWnd, strMsg, 
		_T("Warning"), MB_YESNO | MB_ICONWARNING))
	{
		CDialog::OnOK();
	}
}

/***************************************
ıȡֵANSI
***************************************/
string CHashDlg::GetEditTextA(HWND hwnd)
{
	int nLen = ::SendMessageA(hwnd,
		WM_GETTEXTLENGTH, 0, 0);

	char* szBuf = new char[nLen + 1];
	memset(szBuf, 0, nLen + 1);
	::SendMessageA(hwnd, WM_GETTEXT, nLen + 1, (LONG)szBuf);

	string strResult = szBuf;
	delete[] szBuf;
	return strResult;
}

/***************************************
㷨л
***************************************/
void CHashDlg::OnSelchangeComboAlgorithm() 
{
	int nIndex = m_cbxAlgorithm.GetCurSel();

	if (0 == nIndex || 1 == nIndex)
	{
		::EnableWindow(GetDlgItem(IDC_EDIT_KEY)->m_hWnd, FALSE);
		::EnableWindow(GetDlgItem(IDC_CHECK_HMAC)->m_hWnd, FALSE);
		SetDlgItemText(IDC_EDIT_KEY, _T(""));
	}
	else
	{
		::EnableWindow(GetDlgItem(IDC_EDIT_KEY)->m_hWnd, TRUE);
		::EnableWindow(GetDlgItem(IDC_CHECK_HMAC)->m_hWnd, TRUE);
	}

	OnChangeEditData();
}

/***************************************
[HMAC]ѡ
***************************************/
void CHashDlg::OnCheckHmac() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK_HMAC))->GetCheck())
	{
		((CEdit*)GetDlgItem(IDC_EDIT_KEY))->SetReadOnly(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT_KEY))->SetFocus();
	}
	else
	{
		((CEdit*)GetDlgItem(IDC_EDIT_KEY))->SetReadOnly(TRUE);
		CString strKey;
		GetDlgItemText(IDC_EDIT_KEY, strKey);
		if (!strKey.IsEmpty())
			SetDlgItemText(IDC_EDIT_KEY, _T(""));
	}
	
}

/***************************************
ʼļ
***************************************/
void CHashDlg::OnBtnCalculate() 
{
	//
	// ֹͣǰļļ
	//

	CString strBtnText;
	GetDlgItemText(IDC_BTN_CALCULATE, strBtnText);
	if (strBtnText == _T("Stop"))
	{
		CString strMsg;
		strMsg.LoadString(IDS_STOP_MSG);
		
		if (IDYES == ::MessageBox(m_hWnd, strMsg, 
			_T("Warning"), MB_YESNO | MB_ICONWARNING))
		{
			if (NULL != m_pHashCalc)
			{
				m_pHashCalc->FileStop();
			}
		}

		return;
	}

	//
	// ̼߳ļ
	//

	void* pProc = m_pThreadProc.Stdcall(this, 
		Thunk::GetMemberFxnAddr(&CHashDlg::ThreadProc));
	HANDLE hThread = CreateThread(NULL, NULL, 
		(LPTHREAD_START_ROUTINE)pProc, NULL, NULL, NULL);
	CloseHandle(hThread);
}

/***************************************
ļ̺߳
***************************************/
DWORD __stdcall CHashDlg::ThreadProc(LPVOID lpParam)
{
	CString strFileName;
	GetDlgItemText(IDC_EDIT_DATA, strFileName);
	if (strFileName.IsEmpty())
	{
		CString strTmp;
		strTmp.LoadString(IDS_NO_FILENAME);
		AfxMessageBox(strTmp);
		return 0;
	}

	SetDlgItemText(IDC_BTN_CALCULATE, _T("Stop"));
	int nIndex = m_cbxAlgorithm.GetCurSel();

	if (NULL != m_pHashCalc)
		delete m_pHashCalc;

	switch (nIndex)
	{
	case 0: // CRC32
		{
			m_pHashCalc = new HashCalc(HashCalc::E_CRC32);
			break;

		}
	case 1: // Adler32
		{
			m_pHashCalc = new HashCalc(HashCalc::E_ADLER32);
			break;
		}
	case 2: // Tiger
		{
			m_pHashCalc = new HashCalc(HashCalc::E_TIGER);
			break;
		}
	case 3: // Panama
		{
			m_pHashCalc = new HashCalc(HashCalc::E_PANAMA);
			break;
		}
	case 4: // Whirlpool
		{
			m_pHashCalc = new HashCalc(HashCalc::E_WHIRLPOOL);
			break;
		}
	case 5: // MD2
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD2);
			break;
		}
	case 6: // MD4
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD4);
			break;
		}
	case 7: // MD5
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD5);
			break;
		}
	case 8: // RIPEMD-128
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_128);
			break;
		}
	case 9: // RIPEMD-160
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_160);
			break;
		}
	case 10: // RIPEMD-256
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_256);
			break;
		}
	case 11: // RIPEMD-320
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_320);
			break;
		}
	case 12: // SHA1
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA1);
			break;
		}
	case 13: // SHA2-224
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA2_224);
			break;
		}
	case 14: // SHA2-256
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA2_256);
			break;
		}
	case 15: // SHA4-384
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA4_384);
			break;
		}
	case 16: // SHA4-512
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA4_512);
			break;
		}
	}

	BOOL bHmac = ((CButton*)GetDlgItem(IDC_CHECK_HMAC))->GetCheck();
	BOOL bUppercase = ((CButton*)GetDlgItem(IDC_CHECK_UPPDRCASE))->GetCheck();
	string strKey = 
		GetEditTextA(GetDlgItem(IDC_EDIT_KEY)->m_hWnd);	

	Enable(FALSE);
	m_bIsStarting = TRUE;

	tstring strResult = m_pHashCalc->GetFileResult((TCHAR*)(LPCTSTR)strFileName, strKey,
		bHmac, bUppercase, MemberFxn(this, &CHashDlg::Progress));

	if (strResult.empty() && !m_pHashCalc->IsUserStop())
	{
		ShowErrorInfo(m_pHashCalc->GetError());
		m_Pos.SetPos(0);
	}
	else if (m_pHashCalc->IsUserStop())
	{
		m_Pos.SetPos(0);
	}

	Enable(TRUE);

	delete m_pHashCalc;
	m_pHashCalc = NULL;
	m_bIsStarting = FALSE;

	SetDlgItemText(IDC_BTN_CALCULATE, _T("Start"));
	SetDlgItemText(IDC_EDIT_RESULT, strResult.c_str());

	return 1;
}

/***************************************
ʼַ
***************************************/
void CHashDlg::OnChangeEditKey() 
{
	OnChangeEditData();
}

/***************************************
ʼַ
***************************************/
void CHashDlg::OnChangeEditData()
{
	//
	// ļѡѡ, ֱӷ
	//

	if (((CButton*)GetDlgItem(IDC_RADIO_FILE))->GetCheck())
	{
		SetDlgItemText(IDC_EDIT_RESULT, _T(""));
		m_Pos.SetPos(0);
		return ;
	}

	//
	// ȡû
	//

	string strInput = 
		GetEditTextA(GetDlgItem(IDC_EDIT_DATA)->m_hWnd);
	if (strInput.empty())
	{
		SetDlgItemText(IDC_EDIT_RESULT, _T(""));
		m_Pos.SetPos(0);
		return;
	}

	BOOL bHmac = ((CButton*)GetDlgItem(IDC_CHECK_HMAC))->GetCheck();
	string strKey = 
		GetEditTextA(GetDlgItem(IDC_EDIT_KEY)->m_hWnd);

	BOOL bUppercase = ((CButton*)GetDlgItem(IDC_CHECK_UPPDRCASE))->GetCheck();

	int nIndex = m_cbxAlgorithm.GetCurSel();

	switch (nIndex)
	{
	case 0: // CRC32
		{
			m_pHashCalc = new HashCalc(HashCalc::E_CRC32);
			break;

		}
	case 1: // Adler32
		{
			m_pHashCalc = new HashCalc(HashCalc::E_ADLER32);
			break;
		}
	case 2: // Tiger
		{
			m_pHashCalc = new HashCalc(HashCalc::E_TIGER);
			break;
		}
	case 3: // Panama
		{
			m_pHashCalc = new HashCalc(HashCalc::E_PANAMA);
			break;
		}
	case 4: // Whirlpool
		{
			m_pHashCalc = new HashCalc(HashCalc::E_WHIRLPOOL);
			break;
		}
	case 5: // MD2
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD2);
			break;
		}
	case 6: // MD4
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD4);
			break;
		}
	case 7: // MD5
		{
			m_pHashCalc = new HashCalc(HashCalc::E_MD5);
			break;
		}
	case 8: // RIPEMD-128
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_128);
			break;
		}
	case 9: // RIPEMD-160
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_160);
			break;
		}
	case 10: // RIPEMD-256
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_256);
			break;
		}
	case 11: // RIPEMD-320
		{
			m_pHashCalc = new HashCalc(HashCalc::E_RIPEMD_320);
			break;
		}
	case 12: // SHA1
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA1);
			break;
		}
	case 13: // SHA2-224
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA2_224);
			break;
		}
	case 14: // SHA2-256
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA2_256);
			break;
		}
	case 15: // SHA4-384
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA4_384);
			break;
		}
	case 16: // SHA4-512
		{
			m_pHashCalc = new HashCalc(HashCalc::E_SHA4_512);
			break;
		}
	}

	tstring strResult = m_pHashCalc->GetStringResult(strInput, 
		strKey, bHmac, bUppercase);
	
	delete m_pHashCalc;
	m_pHashCalc = NULL;
	SetDlgItemText(IDC_EDIT_RESULT, strResult.c_str());	
}

/***************************************
ļʱĻص, ʾ
ļ
***************************************/
void CHashDlg::Progress(int n)
{
	m_Pos.SetPos(n);
}

/***************************************
ʾϢ
***************************************/
void CHashDlg::ShowErrorInfo(DWORD dwCode)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, dwCode,
		0, // Default language
		(LPTSTR) &lpMsgBuf, 0, NULL);
	AfxMessageBox((LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

/***************************************
ֹسESC˳
***************************************/
BOOL CHashDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class

	if (WM_KEYDOWN == pMsg->message)
	{
		if (VK_RETURN == pMsg->wParam || VK_ESCAPE == pMsg->wParam)
		{
			return 1;
		}
		else
		{
			BOOL bCTRL = (GetKeyState(VK_LCONTROL) >> 15 & 1 || 
				GetKeyState(VK_RCONTROL) >> 15 & 1) ? TRUE : FALSE;
			if((pMsg->wParam == 'A' || pMsg->wParam == 'a') && bCTRL)
			{
				CString strInput;
				if (GetDlgItem(IDC_EDIT_DATA)->m_hWnd == pMsg->hwnd)
				{
					GetDlgItemText(IDC_EDIT_DATA, strInput);
					if (!strInput.IsEmpty())
					{
						::SendMessage(GetDlgItem(IDC_EDIT_DATA)->m_hWnd, EM_SETSEL,
							0, strInput.GetLength());
					}
				}
				else if (GetDlgItem(IDC_EDIT_KEY)->m_hWnd == pMsg->hwnd)
				{
					GetDlgItemText(IDC_EDIT_KEY, strInput);
					if (!strInput.IsEmpty())
					{
						::SendMessage(GetDlgItem(IDC_EDIT_KEY)->m_hWnd, EM_SETSEL,
							0, strInput.GetLength());
					}
				}
				else if (GetDlgItem(IDC_EDIT_RESULT)->m_hWnd == pMsg->hwnd)
				{
					GetDlgItemText(IDC_EDIT_RESULT, strInput);
					if (!strInput.IsEmpty())
					{
						::SendMessage(GetDlgItem(IDC_EDIT_RESULT)->m_hWnd, EM_SETSEL,
							0, strInput.GetLength());
					}
				}
			}			
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

/***************************************
ûýϵпؼ
***************************************/
void CHashDlg::Enable(BOOL bEnable)
{
	::EnableWindow(GetDlgItem(IDC_COMBO_ALGORITHM)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_RADIO_STRING)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_RADIO_FILE)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_EDIT_DATA)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_BTN_BROWSE)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_EDIT_RESULT)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_BTN_COPY)->m_hWnd, bEnable);
	// ::EnableWindow(GetDlgItem(IDC_BTN_CALCULATE)->m_hWnd, bEnable);
	::EnableWindow(GetDlgItem(IDC_CHECK_UPPDRCASE)->m_hWnd, bEnable);

	if (bEnable)
	{
		int nIndex = m_cbxAlgorithm.GetCurSel();
		::EnableWindow(GetDlgItem(IDC_CHECK_HMAC)->m_hWnd, 
			0 == nIndex || 1 == nIndex ? FALSE : TRUE);
	}
	else
	{
		::EnableWindow(GetDlgItem(IDC_CHECK_HMAC)->m_hWnd, FALSE);
	}	
}

