
/*++

Autor: Zhang Luduo (³)
Email: Support@ZhangLuduo.com 
MSN  : ZhangLuduo@msn.com
WEB  : http://www.ZhangLuduo.com/

Copyright 2006-2009 Zhang Luduo. All rights reserved.

--*/

/*++

ļд, ڴӳļԭʵ, Զ
ļжд. ڴӳļص, 
Ҫ׷дļ

2009-04-21
һwindows98µصbug, һ
Աn_pbRWm_pbFileĸֵ

--*/

#include "stdafx.h"
#include "File.h"
#include <assert.h>

File::File()
{
	//
	// ȡϵͳ
	//

	SYSTEM_INFO si;	
	GetSystemInfo(&si);    
	m_nSysGranularity = si.dwAllocationGranularity;

	//
	// ʼ
	//

	m_hFile         = NULL;
	m_hMapping      = NULL;
	m_pbFile        = NULL;
	n_pbRW          = NULL;
	m_nPosition     = 0;
	m_nSize         = INVALID_FILE_SIZE;
	m_dwAccess      = GENERIC_READ;
	m_dwErrorCode   = 0;
}

File::~File()
{
	Close();
}

BOOL File::Open(TCHAR* FileName, DWORD dwAccess, DWORD dwShareMode)
{
	assert(FileName);

	m_nPosition = 0;
	m_nSize     = 0;
	m_dwAccess      = dwAccess; 

	if (NULL != m_hFile || NULL != m_hMapping || 
		NULL != m_pbFile)
	{
		if (!Close())
		{
			m_dwAccess = GENERIC_READ;
			return FALSE;
		}
	}

	m_hFile = CreateFile(FileName, dwAccess, dwShareMode, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if (INVALID_HANDLE_VALUE == m_hFile || NULL == m_hFile) 
	{
		m_dwErrorCode = GetLastError();
		m_hFile       = NULL;
		m_dwAccess    = GENERIC_READ;
		return FALSE;
	}

	DWORD dwFileSizeHigh = 0;
	m_nSize = ::GetFileSize(m_hFile, &dwFileSizeHigh);
	m_nSize += (((DWORD64) dwFileSizeHigh) << 32);

	m_dwErrorCode = 0;

	return TRUE;
}

BOOL File::Create(TCHAR* FileName, DWORD64 FileSize, 
				  DWORD dwCreationDisposition, DWORD dwShareMode)
{
	assert(FileName);

	m_nPosition = 0;
	m_nSize     = FileSize;
	m_dwAccess      = GENERIC_READ | GENERIC_WRITE;	

	if (NULL != m_hFile || NULL != m_hMapping || 
		NULL != m_pbFile)
	{
		if (!Close())
		{
			m_nSize = 0;
			m_dwAccess  = GENERIC_READ;
			return FALSE;
		}
	}

	m_hFile = CreateFile(FileName, GENERIC_READ | GENERIC_WRITE, 
		dwShareMode, NULL, dwCreationDisposition, 
		FILE_ATTRIBUTE_NORMAL, 0);

	if (INVALID_HANDLE_VALUE == m_hFile || NULL == m_hFile) 
	{
		m_dwErrorCode = GetLastError();
		m_hFile      = NULL;
		m_nSize  = 0;
		m_dwAccess   = GENERIC_READ;
		return FALSE;
	}

	if (FileSize <= 0)
	{
		m_dwErrorCode = 0;
		return TRUE;
	}

	m_hMapping = ::CreateFileMapping(m_hFile, NULL, PAGE_READWRITE, 
		(DWORD)(m_nSize >> 32), (DWORD)m_nSize, NULL);
	
	if (NULL == m_hMapping)
	{
		m_dwErrorCode = GetLastError();
		return FALSE;
	}

	m_dwErrorCode = 0;
	return  TRUE;
}

BOOL File::AppendSize(DWORD dwAppendSize)
{
//	if (INVALID_HANDLE_VALUE == m_hFile || NULL == m_hFile) 
//	{
//		return FALSE;
//	}

	assert(!(INVALID_HANDLE_VALUE == m_hFile));
	assert(!(NULL == m_hFile));

	if (m_pbFile)
	{
		if (::UnmapViewOfFile(m_pbFile))
		{
			m_pbFile = NULL;
		}
	}

	if (m_hMapping)
	{
		if (CloseHandle(m_hMapping))
		{
			m_hMapping = NULL;
		}
	}

	m_nSize += dwAppendSize;

	m_hMapping = ::CreateFileMapping(m_hFile, NULL, 
		m_dwAccess & GENERIC_WRITE ? PAGE_READWRITE : PAGE_READONLY, 
		(DWORD)(m_nSize >> 32), (DWORD)m_nSize, NULL );	

	if (NULL == m_hMapping)
	{
		m_dwErrorCode = GetLastError();
		m_nSize -= dwAppendSize;		
		return FALSE;
	}
	else
	{
		m_dwErrorCode = 0;
		return TRUE;
	}
}

BOOL File::Close()
{
	if (m_pbFile)
	{
		if (::UnmapViewOfFile(m_pbFile))
		{
			m_pbFile = NULL;
		}
	}

	if (m_hMapping)
	{
		if (CloseHandle(m_hMapping))
		{
			m_hMapping = NULL;
		}
	}

	if (m_hFile)
	{
		if (CloseHandle(m_hFile))
		{
			m_hFile = NULL;
		}
	}

	m_nPosition = 0;
	m_nSize     = 0;
	m_dwAccess      = GENERIC_READ;

	if (!(NULL == m_hFile && NULL == m_hMapping && 
		NULL == m_pbFile))
	{
		m_dwErrorCode = GetLastError();
		return FALSE;
	}

	m_dwErrorCode = 0;
	return TRUE;
}

DWORD64 File::GetFileSize()
{
	return m_nSize;
}

DWORD64 File::GetPosition()
{
	return m_nPosition;
}

DWORD64 File::SetPosition(DWORD64 nPos)
{
	if (nPos >= m_nSize)
	{
		m_nPosition = m_nSize;
		return m_nPosition;
	}
	
	if (nPos <= 0)
	{
		m_nPosition = 0;
		return m_nPosition;
	}
	
	m_nPosition = nPos;
	return m_nPosition;
}

/*
:
	ݵǰļָλ(m_nFilePointer), ûҪӳ
	ֽ(ViewSize)ļӳ䵽ڴ, ҷûɶдֽ

	漰:
	1 ļָλ(m_nFilePointer)ӽϵͳȵֵ
	ֵΪӳĻַ
	2 ӳֽ, ֵӳַܳļܳ
*/
DWORD File::MapView(DWORD ViewSize)
{
	assert(m_hFile);

	if (NULL == m_hMapping)
	{
		if (m_nSize <= 0)
		{
			// MessageId: ERROR_FILE_INVALID
			//
			// MessageText:
			//
			//  The volume for a file has been externally altered so that the
			//  opened file is no longer valid.
			//
			//	#define ERROR_FILE_INVALID               1006L
			//
			//SetLastError(ERROR_FILE_INVALID);

			m_dwErrorCode = ERROR_FILE_INVALID;

			return 0;
		}

		if (m_dwAccess & GENERIC_WRITE)
		{
			m_hMapping = ::CreateFileMapping(m_hFile, NULL, 
				PAGE_READWRITE, (DWORD)(m_nSize >> 32), 
				(DWORD)m_nSize, NULL);
		}
		else if (m_dwAccess & GENERIC_READ)
		{
			m_hMapping = ::CreateFileMapping(m_hFile, NULL, 
				PAGE_READONLY, (DWORD)(m_nSize >> 32), 
				(DWORD)m_nSize, NULL);
		}
		if (NULL == m_hMapping)
		{
			m_dwErrorCode = GetLastError();
			return 0;
		}
	}

	// ݵǰļָ(m_nFilePointer)λüʵӳλ, 
	// ֵϵͳȵ
	DWORD64 nRealPos = (m_nPosition / m_nSysGranularity) * m_nSysGranularity;

	//
	// ʵӦӳֽڳ
	//

	DWORD64 nRealMapLen = ViewSize + (m_nPosition - nRealPos);
	if (nRealMapLen > m_nSize - nRealPos)
	{
		nRealMapLen = m_nSize - nRealPos;
	}

	if (NULL != m_pbFile) 
	{
		if (!::UnmapViewOfFile(m_pbFile))
		{
			m_dwErrorCode = GetLastError();
			// return 0;
		}
	}

	m_pbFile = (PBYTE)::MapViewOfFile(m_hMapping, 
						m_dwAccess & GENERIC_WRITE ? FILE_MAP_WRITE : FILE_MAP_READ, 
						(DWORD)(nRealPos >> 32), (DWORD)nRealPos, (DWORD)nRealMapLen);

	if (NULL == m_pbFile) 
	{
		m_dwErrorCode = GetLastError();
		return 0;
	}

	n_pbRW = m_pbFile + (m_nPosition - nRealPos);
	return (DWORD) (nRealMapLen - (m_nPosition - nRealPos));
}

DWORD File::Read(void *Buffer, DWORD BufferLen)
{
	assert(Buffer);

	DWORD MapSize = MapView(BufferLen);
	if (0 == MapSize)
		return 0;

	assert(m_pbFile);

	memcpy(Buffer, n_pbRW, MapSize);
	SetPosition(m_nPosition + MapSize);

	return MapSize;
}

DWORD File::Write(void *pData, DWORD DataLen)
{
	assert(pData);

	DWORD MapSize = MapView(DataLen);
	if (0 == MapSize)
		return 0;

	assert(m_pbFile);

	memcpy(n_pbRW, pData, MapSize);
	SetPosition(m_nPosition + MapSize);

	return MapSize;
}

DWORD File::AppendWrite(void *pData, DWORD DataLen)
{
	if (!AppendSize((DWORD)DataLen)) 
		return 0;

	SetPosition(m_nSize - DataLen);
	return Write(pData, DataLen);
}

DWORD File::GetErrorCode()
{
	return m_dwErrorCode;
}