
/*++

Autor: Zhang Luduo (³)
Email: Support@ZhangLuduo.com 
MSN  : ZhangLuduo@msn.com
WEB  : http://www.ZhangLuduo.com/

Copyright 2006-2009 Zhang Luduo. All rights reserved.

--*/

#include "stdafx.h"
#include <assert.h>
#include "HyperLink.h"

#include <Commctrl.h>
#pragma comment(lib, "Comctl32.lib")

#ifndef IDC_HAND
#	define IDC_HAND MAKEINTRESOURCE(32649)
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const TCHAR* szHyperLinkProp = 
			_T("HyperLink::PROP_OBJECT_PTR");

vector<HyperLink::SUBWND_INTO> HyperLink::m_SubwndInfo;

HyperLink::HyperLink()
{
	m_hWnd              = NULL;
	m_PrevHyperLinkProc = NULL;
	m_PrevParentWndProc = NULL;

	m_ColorInfo.Normal  = 0xFF0000;
	m_ColorInfo.Hover   = 0xFF00FF;
	m_ColorInfo.Active  = 0x0000FF;
	m_ColorInfo.Visited = 0x800080;

	m_bHover      = FALSE;
	m_bVisited    = FALSE;
	m_LButtonDown = FALSE;

	m_UnderlineShow          = MOUSEMOVE;
	m_FontInfo.StdFont       = NULL;
	m_FontInfo.UnderlineFont = NULL;

	m_strText = _T("");
	m_strURL  = _T("");
	m_hCursor = LoadCursor(NULL, IDC_HAND);
}

HyperLink::~HyperLink()
{
	Detach();

	m_hWnd              = NULL;
	m_PrevHyperLinkProc = NULL;
	m_PrevParentWndProc = NULL;

	m_ColorInfo.Normal  = 0xFF0000;
	m_ColorInfo.Hover   = 0xFF00FF;
	m_ColorInfo.Active  = 0x0000FF;
	m_ColorInfo.Visited = 0x800080;

	m_bHover      = FALSE;
	m_bVisited    = FALSE;
	m_LButtonDown = FALSE;

	m_UnderlineShow          = MOUSEMOVE;
	m_FontInfo.StdFont       = NULL;
	m_FontInfo.UnderlineFont = NULL;

	m_strText = _T("");
	m_strURL  = _T("");
	m_hCursor = LoadCursor(NULL, IDC_HAND);
}

BOOL HyperLink::Attach(HWND hWnd)
{
	// 
	// ȷЧ
	//

	if (!IsWindow(hWnd))
	{
		return FALSE;
	}

	//
	// ֹͬһڱظ໯
	//

	if (NULL != m_hWnd)
	{
		if (!Detach())
		{
			return FALSE;
		}
	}

	m_hWnd = hWnd;
	
	if (!m_strText.empty())
		SendMessage(m_hWnd, WM_SETTEXT, 0, (LPARAM)(TCHAR*)(m_strText.c_str()));

	//
	// ໯
	//

	void* pHyperLinkProc = m_pHyperLinkProc.Thiscall(this, 
		Thunk::GetMemberFxnAddr(&HyperLink::HyperLinkProc));

	m_PrevHyperLinkProc = (WNDPROC)SetWindowLong(hWnd, 
		GWL_WNDPROC, (LONG)pHyperLinkProc);

	if (!SetProp(hWnd, szHyperLinkProp, this))
	{
		return FALSE;
	}

	//
	// ໯, ȷͬһֻ໯һ
	// ӶøڵWNDPROC, ڴ˴WM_CTLCOLORSTATIC
	// Ϣ, ԿHyperLinkɫ
	//
	// ͬʱҪ¼ͬһжٸѾ
	// ໯HyperLink, ԱǷԸȡ໯
	// : 2009-11-24

	HWND hParent = GetParent(hWnd);
	BOOL bSubclassed = FALSE;
	for (int i = 0; i < m_SubwndInfo.size(); i++)
	{
		if (m_SubwndInfo[i].hWnd == hParent)
		{
			m_SubwndInfo[i].dwRef++;
			bSubclassed = TRUE;
			break;
		}
	}

	if (!bSubclassed)
	{
		SUBWND_INTO subwndinfo = 
		{ 
			hParent, 
			1
		};
		m_SubwndInfo.push_back(subwndinfo);

		void* pParentWndProc = m_pParentWndProc.Thiscall(this, 
			Thunk::GetMemberFxnAddr(&HyperLink::ParentWndProc));

		m_PrevParentWndProc = (WNDPROC)SetWindowLong(GetParent(hWnd), 
			GWL_WNDPROC, (LONG)pParentWndProc);

		if (NULL == m_PrevParentWndProc)
			return FALSE;
	}

	//
	// ɹ໯Ϣ
	//

	if (NULL != m_PrevHyperLinkProc)
	{
		SetWindowLong(m_hWnd, GWL_STYLE, 
			GetWindowLong(m_hWnd, GWL_STYLE) | SS_NOTIFY);
	

		memset(&m_FontInfo.LogFont, 0, sizeof(LOGFONT));
		m_FontInfo.OriginalFont = (HFONT)::SendMessage(m_hWnd, WM_GETFONT, 0, 0);
		GetObject(m_FontInfo.OriginalFont, sizeof (LOGFONT), &m_FontInfo.LogFont);

		CreateFont().UpdateFont().AdjustFit();

		return TRUE;
	}

	return FALSE;
}

BOOL HyperLink::Detach()
{
	if (NULL == m_hWnd)
		return TRUE;
	
	BOOL bResult = TRUE;

	//
	// HyperLinkȡ໯
	//

	if (IsWindow(m_hWnd))
	{
		RemoveProp(m_hWnd, szHyperLinkProp);
		if (!SetWindowLong(m_hWnd, GWL_WNDPROC, 
			(LONG)m_PrevHyperLinkProc))
			bResult = FALSE;

		if (m_FontInfo.OriginalFont)
		{
			::SendMessage(m_hWnd, WM_SETFONT, 
				(WPARAM)m_FontInfo.OriginalFont, FALSE);
			InvalidateRect(m_hWnd, NULL, TRUE);
		}	
	}

	// ! ͷGDI
	DeleteFont();

	//
	// Ƿȡڵ໯
	// : 2009-11-24
	// 
	
	if (IsWindow(m_hWnd))
	{		
		HWND hParent = ::GetParent(m_hWnd);
		for (int i = 0; i < m_SubwndInfo.size(); i++)
		{
			if ( m_SubwndInfo[i].hWnd == hParent)
			{
				m_SubwndInfo[i].dwRef--;

				if (0 == m_SubwndInfo[i].dwRef && IsWindow(m_SubwndInfo[i].hWnd))
				{
					SetWindowLong(hParent, 
						GWL_WNDPROC, (LONG)m_PrevParentWndProc);
					m_SubwndInfo.erase(m_SubwndInfo.begin() + i, 
						m_SubwndInfo.begin() + i + 1);
					break;
				}
			}
		}
	}

	return bResult;
}

HyperLink::operator HWND() const
{
	return m_hWnd;
}

HyperLink& HyperLink::SetText(TCHAR* strText)
{
	m_strText = strText;

	if (IsWindow(m_hWnd))
	{
		SendMessage(m_hWnd, WM_SETTEXT, 0, (LPARAM)strText);
		AdjustFit();
	}

	return *this;
}

HyperLink& HyperLink::SetURL(TCHAR* strURL)
{
	m_strURL = strURL;
	return *this;
}

HyperLink& HyperLink::SetCursor(HCURSOR hCursor)
{
	m_hCursor = NULL == hCursor ? LoadCursor(NULL, IDC_HAND) : hCursor;
	return *this;
}

HyperLink& HyperLink::DeleteFont()
{
	if (NULL != m_FontInfo.StdFont)
	{
		DeleteObject(m_FontInfo.StdFont);
		m_FontInfo.StdFont = NULL;
	}

	if (NULL != m_FontInfo.UnderlineFont)
	{
		DeleteObject(m_FontInfo.UnderlineFont);
		m_FontInfo.UnderlineFont = NULL;
	}

	return *this;
}

HyperLink& HyperLink::UpdateFont()
{
	if (!IsWindow(m_hWnd))
		return *this;

	switch (m_UnderlineShow)
	{
	case ALWAYS:
		SendMessage(m_hWnd, WM_SETFONT, 
			(WPARAM)m_FontInfo.UnderlineFont, FALSE);
		break;
	case MOUSEMOVE:
		if (m_bHover)
		{
			SendMessage(m_hWnd, WM_SETFONT, 
				(WPARAM)m_FontInfo.UnderlineFont, FALSE);
		}
		else
		{
			SendMessage(m_hWnd, WM_SETFONT, 
				(WPARAM)m_FontInfo.StdFont, FALSE);
		}
		break;
	case NOSHOW:
		SendMessage(m_hWnd, WM_SETFONT, 
			(WPARAM)m_FontInfo.StdFont, FALSE);
		break;
	}
	InvalidateRect(m_hWnd, NULL, TRUE);
	return *this;
}

HyperLink& HyperLink::CreateFont()
{
	m_FontInfo.LogFont.lfUnderline = FALSE;	
	m_FontInfo.StdFont = CreateFontIndirect(&m_FontInfo.LogFont);

	m_FontInfo.LogFont.lfUnderline = TRUE;
	m_FontInfo.UnderlineFont = CreateFontIndirect(&m_FontInfo.LogFont);

	return *this;
}

HyperLink& HyperLink::SetFont(HFONT hFont)
{
	GetObject(hFont, sizeof (LOGFONT), &m_FontInfo.LogFont);
	DeleteFont().CreateFont().UpdateFont().AdjustFit();

	return *this;
}

HyperLink& HyperLink::SetFontBold(BOOL bBold)
{
	m_FontInfo.LogFont.lfWeight = bBold ? FW_BOLD : FW_NORMAL;
	DeleteFont().CreateFont().UpdateFont().AdjustFit();

	return *this;
}

HyperLink& HyperLink::SetFontItalic(BOOL bItalic)
{
	m_FontInfo.LogFont.lfItalic = bItalic ? TRUE : FALSE;
	DeleteFont().CreateFont().UpdateFont().AdjustFit();

	return *this;
}

HyperLink& HyperLink::SetFontSize(int nSize)
{
	if (IsWindow(m_hWnd))
	{
		HDC hDC = GetWindowDC(m_hWnd);
		m_FontInfo.LogFont.lfHeight = -MulDiv(nSize, 
			GetDeviceCaps(hDC, LOGPIXELSY), 72);
		ReleaseDC(m_hWnd, hDC);
	}

	DeleteFont().CreateFont().UpdateFont().AdjustFit();

	return *this;
}

HyperLink& HyperLink::SetFontName(TCHAR* strFontName)
{
	_tcsncpy(m_FontInfo.LogFont.lfFaceName, strFontName, LF_FACESIZE - 1);
	DeleteFont().CreateFont().UpdateFont().AdjustFit();

	return *this;
}

HyperLink& HyperLink::SetColor(COLORREF Color, STATUS_COLOR StatusColor)
{
	switch (StatusColor)
	{
	case NORMAL:
		m_ColorInfo.Normal = Color;
		break;
	case HOVER:
		m_ColorInfo.Hover = Color;
		break;
	case ACTIVE:
		m_ColorInfo.Active = Color;
		break;
	case VISITED:
		m_ColorInfo.Visited = Color;
		break;
	}

	if (IsWindow(m_hWnd))
		InvalidateRect(m_hWnd, NULL, TRUE);

	return *this;
}

HyperLink& HyperLink::SetUnderlineShow(UNDERLINE_SHOW UnderlineShow)
{
	m_UnderlineShow = UnderlineShow;
	return *this;
}

LRESULT HyperLink::HyperLinkProc(HWND hWnd, UINT uMsg, 
								 WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_MOUSEMOVE:

		if (!m_bHover)
		{
			if (NOSHOW == m_UnderlineShow)
			{
				SendMessage(hWnd, WM_SETFONT, 
					(WPARAM)m_FontInfo.StdFont, FALSE);
			}
			else
			{
				SendMessage(hWnd, WM_SETFONT, 
					(WPARAM)m_FontInfo.UnderlineFont, FALSE);
			}
			InvalidateRect(hWnd, NULL, TRUE);
		}

		m_bHover = TRUE;
		::SetCursor(m_hCursor);

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(tme);
		tme.hwndTrack = m_hWnd;
		tme.dwFlags = TME_LEAVE | TME_HOVER;
		tme.dwHoverTime = 1;
		_TrackMouseEvent(&tme);

		break;
	
	case WM_LBUTTONDOWN:

		m_LButtonDown = TRUE;
		::SetCursor(m_hCursor);
		InvalidateRect(hWnd, NULL, TRUE);

		::SendMessage(GetFocus(), WM_KILLFOCUS, NULL, NULL);
		SetFocus(m_hWnd);

		break;

	case WM_LBUTTONUP:

		if (m_LButtonDown)
		{
			m_bVisited = TRUE;
			OnNavigate();
		}

		m_LButtonDown = FALSE;
		::SetCursor(m_hCursor);
		InvalidateRect(hWnd, NULL, TRUE);

		break;

	case WM_MOUSELEAVE:

		if (ALWAYS == m_UnderlineShow)
		{
			SendMessage(hWnd, WM_SETFONT, 
				(WPARAM)m_FontInfo.UnderlineFont, FALSE);
		}
		else
		{
			SendMessage(hWnd, WM_SETFONT, 
				(WPARAM)m_FontInfo.StdFont, FALSE);
		}

		m_bHover = FALSE;
		m_LButtonDown = FALSE;

		InvalidateRect(hWnd, NULL, TRUE);

		break;
	}
	return CallWindowProc(m_PrevHyperLinkProc, 
		hWnd, uMsg, wParam, lParam);
}

LRESULT HyperLink::ParentWndProc(HWND hWnd, UINT uMsg, 
								 WPARAM wParam, LPARAM lParam)
{
	if (uMsg == WM_CTLCOLORSTATIC)
	{
		LRESULT lr = CallWindowProc(m_PrevParentWndProc, 
			hWnd, uMsg, wParam, lParam);

		HWND hCtrlWnd = (HWND)lParam;
		HyperLink* pHyperLink = (HyperLink*)GetProp(hCtrlWnd, 
			szHyperLinkProp);

		if (NULL == pHyperLink)
		{
			return lr;
		}

		if (pHyperLink->m_bVisited)
		{
			::SetTextColor((HDC)wParam, pHyperLink->m_ColorInfo.Visited);
		}
		else
		{
			if (pHyperLink->m_LButtonDown)
				::SetTextColor((HDC)wParam, pHyperLink->m_ColorInfo.Active);
			else if (pHyperLink->m_bHover)
				::SetTextColor((HDC)wParam, pHyperLink->m_ColorInfo.Hover);
			else
				::SetTextColor((HDC)wParam, pHyperLink->m_ColorInfo.Normal);
		}
		return lr;
	}

	return CallWindowProc(m_PrevParentWndProc, hWnd, uMsg, wParam, lParam);
}

// ݱǩе־εڴС
HyperLink& HyperLink::AdjustFit()
{
	assert(m_hWnd);

	if (!IsWindow(m_hWnd) || NULL == m_FontInfo.StdFont)
		return *this;

	DWORD dwLen = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0, 0);
	TCHAR* pBuffer = new TCHAR[dwLen + 1];
	SendMessage(m_hWnd, WM_GETTEXT, dwLen + 1, (LPARAM)pBuffer);

	HDC hdc = GetDC(m_hWnd);
	HGDIOBJ hOld = SelectObject(hdc, m_FontInfo.StdFont);

	RECT rtText = { 0 };
	DrawText(hdc, pBuffer, -1, &rtText, DT_CALCRECT);
//	rtText.right += 2;
//	rtText.bottom += 2;	

	delete[] pBuffer;

	SelectObject(hdc, hOld);
	::DeleteObject(hOld);
	::ReleaseDC(m_hWnd, hdc);

	SetWindowPos(m_hWnd, NULL, 0, 0, rtText.right, 
		rtText.bottom, SWP_NOMOVE);

	return *this;
}

void HyperLink::OnNavigate()
{
	if (m_strURL.empty())
	{
		return;
	}

	SHELLEXECUTEINFO sei = { 0 };
	
	sei.cbSize = sizeof (SHELLEXECUTEINFO);
	sei.lpVerb = _T("open");
	sei.lpFile = m_strURL.c_str();
	sei.nShow  = SW_SHOWNORMAL;

	ShellExecuteEx(&sei);
}