
/*++

Autor: Zhang Luduo (³)
Email: zhangluduo@163.com
MSN  : zhangluduo@msn.com
Web  : http://www.zhangluduo.com/

Copyright 2006-2009 Zhang Luduo. 
All rights reserved.
  
--*/

/*++

:
һC++Աַ

--*/

#ifndef _MEMBERFXN_H
#define _MEMBERFXN_H

//
// type redefinition
//

typedef unsigned char  u1byte; // an 8 bit unsigned character type
typedef unsigned short u2byte; // a 16 bit unsigned integer type
typedef unsigned long  u4byte; // a 32 bit unsigned integer type
typedef char           s1byte; // an 8 bit signed character type
typedef short          s2byte; // a 16 bit signed integer type
typedef long           s4byte; // a 32 bit signed integer type
typedef void*          pvoid;  // a 32 bit undefined type pointer

class MemberFxn 
{
public:

	//
	// Construction and destruction
	//

	MemberFxn();
	MemberFxn(int);
	MemberFxn(MemberFxn& addr);
	~MemberFxn();

	template<typename T> 
	MemberFxn(pvoid This, T MemberFxnName)
	{
		SetAddr(This, MemberFxnName);
	}

	//
	// Operators
	//

	MemberFxn& operator = (int);
	MemberFxn& operator = (MemberFxn& addr);
	bool operator == (MemberFxn& addr);

	//
	// Attributes
	//

	bool IsNull();
	pvoid GetThis();
	u4byte GetAddr();

	template<typename T> 
	void SetAddr(pvoid This, T MemberFxnName)
	{
		union 
		{
			T From; 
			u4byte To; 
		}	union_cast;
		union_cast.From = MemberFxnName;
		m_MemberFxnAddr = union_cast.To;
		m_This = This;
	}

private:

	//
	// Member data
	//

	pvoid m_This;
	u4byte m_MemberFxnAddr;
};

#endif // _MEMBERFXN_H